(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("redux-extra"), require("lodash/assign"), require("react-router/lib/Route"), require("react-router/lib/Router"), require("react-router/lib/IndexRoute"), require("react-router/lib/useRouterHistory"), require("history/lib/createMemoryHistory"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "redux-extra", "lodash/assign", "react-router/lib/Route", "react-router/lib/Router", "react-router/lib/IndexRoute", "react-router/lib/useRouterHistory", "history/lib/createMemoryHistory"], factory);
	else if(typeof exports === 'object')
		exports["react-redux-extra"] = factory(require("react"), require("redux-extra"), require("lodash/assign"), require("react-router/lib/Route"), require("react-router/lib/Router"), require("react-router/lib/IndexRoute"), require("react-router/lib/useRouterHistory"), require("history/lib/createMemoryHistory"));
	else
		root["react-redux-extra"] = factory(root["react"], root["redux-extra"], root["lodash/assign"], root["react-router/lib/Route"], root["react-router/lib/Router"], root["react-router/lib/IndexRoute"], root["react-router/lib/useRouterHistory"], root["history/lib/createMemoryHistory"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_0__, __WEBPACK_EXTERNAL_MODULE_1__, __WEBPACK_EXTERNAL_MODULE_5__, __WEBPACK_EXTERNAL_MODULE_6__, __WEBPACK_EXTERNAL_MODULE_7__, __WEBPACK_EXTERNAL_MODULE_8__, __WEBPACK_EXTERNAL_MODULE_9__, __WEBPACK_EXTERNAL_MODULE_10__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 3);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("redux-extra");

/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export TRANSITION */
/* unused harmony export UPDATE_LOCATION */
/* unused harmony export push */
/* unused harmony export replace */
/* unused harmony export go */
/* unused harmony export goBack */
/* unused harmony export goForward */
/* unused harmony export pushstep */
/* unused harmony export setBackAction */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return routeActions; });
/* harmony export (immutable) */ __webpack_exports__["c"] = routeReducer;
/* harmony export (immutable) */ __webpack_exports__["d"] = syncHistory;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_router_lib_Route__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_react_router_lib_Route___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_react_router_lib_Route__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_react_router_lib_Router__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_react_router_lib_Router___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_react_router_lib_Router__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_react_router_lib_IndexRoute__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_react_router_lib_IndexRoute___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_react_router_lib_IndexRoute__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_react_router_lib_useRouterHistory__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_react_router_lib_useRouterHistory___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_react_router_lib_useRouterHistory__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_history_lib_createMemoryHistory__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_history_lib_createMemoryHistory___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_history_lib_createMemoryHistory__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_redux_extra__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_redux_extra___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_redux_extra__);
var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }









var currentRoute = "#";
var currentStep = 0;
var stepAction = null;
var pushBackAction = null;
var isOneTimeBackAction = false;

var RouteManager = function () {
    function RouteManager() {
        _classCallCheck(this, RouteManager);

        this.appHistory = __WEBPACK_IMPORTED_MODULE_4_react_router_lib_useRouterHistory___default()(__WEBPACK_IMPORTED_MODULE_5_history_lib_createMemoryHistory___default.a)({ queryKey: false });
        var self = this;
        if (window) {
            window.history.pushState({}, "", "#");
            window.onpopstate = function (ev) {
                var backRoute = null;
                window.history.pushState({}, "", "#");
                var routeSplit = currentRoute.split('/');
                if (routeSplit[0] == "") routeSplit.splice(0, 1);
                var startRouteModel = self.routes.route.childRoutes;
                while (routeSplit.length > 0) {
                    var found = false;
                    for (var i = 0; i < startRouteModel.length; i++) {
                        if (startRouteModel[i].path == routeSplit[0]) {
                            if (routeSplit.length == 1) {
                                found = true;
                                backRoute = startRouteModel[i].backroute;
                                routeSplit.splice(0, 1);
                                break;
                            } else {
                                found = true;
                                routeSplit.splice(0, 1);
                                startRouteModel = startRouteModel[i].childRoutes;
                                break;
                            }
                        }
                    }
                    if (!found) {
                        routeSplit.splice(0, 1);
                    }
                }
                if (currentStep > 0 && stepAction) {
                    if (pushBackAction) {
                        pushBackAction();
                        if (isOneTimeBackAction) pushBackAction = null;
                    } else {
                        currentStep--;
                        __WEBPACK_IMPORTED_MODULE_6_redux_extra__["store"].dispatch({
                            type: stepAction,
                            payload: currentStep
                        });
                    }
                } else {

                    if (pushBackAction) {
                        pushBackAction();
                    } else {
                        if (backRoute && backRoute != currentRoute && currentRoute != '#') {
                            __WEBPACK_IMPORTED_MODULE_6_redux_extra__["store"].dispatch({
                                type: TRANSITION,
                                payload: { method: 'replace', arg: backRoute }
                            });
                        }
                    }
                }
            };
        }

        if (document) {
            document.addEventListener('AppBuilderCustomNavigation', function (e) {
                if (e.route) {
                    __WEBPACK_IMPORTED_MODULE_6_redux_extra__["store"].dispatch({
                        type: TRANSITION,
                        payload: { method: 'replace', arg: e.route }
                    });
                }
            }, false);
        }
    }

    _createClass(RouteManager, [{
        key: 'getHistory',
        value: function getHistory() {
            return this.appHistory;
        }
    }, {
        key: 'generateRoutes',
        value: function generateRoutes(model) {
            this.routes = model;

            return __WEBPACK_IMPORTED_MODULE_0_react___default.a.createElement(__WEBPACK_IMPORTED_MODULE_2_react_router_lib_Router___default.a, { history: this.appHistory, routes: model.route });
        }
    }]);

    return RouteManager;
}();

var routeManager = new RouteManager();
/* harmony default export */ __webpack_exports__["a"] = (routeManager);
var TRANSITION = '@@router/TRANSITION';
var UPDATE_LOCATION = '@@router/UPDATE_LOCATION';
var SELECT_LOCATION = function SELECT_LOCATION(state) {
    return state.routing.location;
};

function transition(method) {
    return function (arg) {
        __WEBPACK_IMPORTED_MODULE_6_redux_extra__["store"].dispatch({
            type: TRANSITION, payload: { method: method, arg: arg }
        });
    };
}

var push = transition('push');
var replace = transition('replace');
var go = transition('go');
var goBack = transition('goBack');
var goForward = transition('goForward');
var pushstep = function pushstep(step, action) {
    currentStep = step;
    stepAction = action;
    __WEBPACK_IMPORTED_MODULE_6_redux_extra__["store"].dispatch({
        type: action,
        payload: step
    });
};
var setBackAction = function setBackAction(action) {
    var isOneTime = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    pushBackAction = action;
    isOneTimeBackAction = isOneTime;
};
var routeActions = { push: push, replace: replace, go: go, goBack: goBack, goForward: goForward, pushstep: pushstep, setBackAction: setBackAction };

function updateLocation(location) {
    currentRoute = location.pathname;
    currentStep = 0;
    stepAction = null;
    if (isOneTimeBackAction) pushBackAction = null;
    return {
        type: UPDATE_LOCATION,
        payload: location
    };
}

var initialState = {
    location: undefined
};

function routeReducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var _ref = arguments[1];
    var type = _ref.type,
        location = _ref.payload;

    if (type !== UPDATE_LOCATION) {
        return state;
    }
    return _extends({}, state, { location: location });
}

function syncHistory(history) {
    var unsubscribeHistory = void 0,
        currentKey = void 0,
        unsubscribeStore = void 0;
    var connected = false,
        syncing = false;

    function middleware(store) {
        unsubscribeHistory = history.listen(function (location) {
            currentKey = location.key;
            if (syncing) {
                return;
            }
            store.dispatch(updateLocation(location));
        });
        connected = true;
        return function (next) {
            return function (action) {
                if (!action || action.type !== TRANSITION || !connected) {
                    return next(action);
                }
                var _action$payload = action.payload,
                    method = _action$payload.method,
                    arg = _action$payload.arg;

                history[method](arg);
            };
        };
    }

    middleware.listenForReplays = function (store) {
        var selectLocationState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : SELECT_LOCATION;

        var getLocationState = function getLocationState() {
            return selectLocationState(store.getState());
        };
        var initialLocation = getLocationState();

        unsubscribeStore = store.subscribe(function () {
            var location = getLocationState();
            if (!location) {
                history.transitionTo(initialLocation);
                return;
            }
            if (location.key !== currentKey) {
                syncing = true;
                history.transitionTo(location);
                syncing = false;
            }
        });
    };

    middleware.unsubscribe = function () {
        unsubscribeHistory();
        if (unsubscribeStore) {
            unsubscribeStore();
        }
        connected = false;
    };
    return middleware;
}

/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__basepage__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__router__ = __webpack_require__(2);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "BasePage", function() { return __WEBPACK_IMPORTED_MODULE_0__basepage__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "routeManager", function() { return __WEBPACK_IMPORTED_MODULE_1__router__["a"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "routeReducer", function() { return __WEBPACK_IMPORTED_MODULE_1__router__["c"]; });
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "syncHistory", function() { return __WEBPACK_IMPORTED_MODULE_1__router__["d"]; });





/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return BasePage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_react___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_react__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_redux_extra__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_redux_extra___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_redux_extra__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_lodash_assign__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_lodash_assign___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_lodash_assign__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__router__ = __webpack_require__(2);
var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }






var BasePage = function (_React$Component) {
    _inherits(BasePage, _React$Component);

    function BasePage(props) {
        _classCallCheck(this, BasePage);

        var _this = _possibleConstructorReturn(this, (BasePage.__proto__ || Object.getPrototypeOf(BasePage)).call(this, props));

        _this.subscriptions = [];
        return _this;
    }

    _createClass(BasePage, [{
        key: 'hashFnv',
        value: function hashFnv(str, seed) {
            var i,
                l,
                hval = seed === undefined ? 0x811c9dc5 : seed;
            for (i = 0, l = str.length; i < l; i++) {
                hval ^= str.charCodeAt(i);
                hval += (hval << 1) + (hval << 4) + (hval << 7) + (hval << 8) + (hval << 24);
            }
            return ("0000000" + (hval >>> 0).toString(16)).substr(-8);
        }
    }, {
        key: 'connect',
        value: function connect(cmpRef) {
            var pageReducers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
            var initalobjectvalues = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

            var reducertags = [];
            if (pageReducers) {
                for (var i = 0; i < pageReducers.length; i++) {
                    var pageReducer = pageReducers[i];
                    var newReducer = {};
                    newReducer[this.hashFnv(pageReducer.toString())] = pageReducer;
                    if (!__WEBPACK_IMPORTED_MODULE_1_redux_extra__["isExternal"]) __WEBPACK_IMPORTED_MODULE_1_redux_extra__["reducerRegistry"].register(newReducer);
                    for (var reducertag in newReducer) {
                        reducertags.push(reducertag);
                        var reducerkey = __WEBPACK_IMPORTED_MODULE_1_redux_extra__["reducerRegistry"].getIncrement();
                        this.subscriptions.push({ path: reducertag, key: reducerkey });
                        Object(__WEBPACK_IMPORTED_MODULE_1_redux_extra__["subscribe"])(reducertag, reducerkey, function (payload) {
                            var currentState = __WEBPACK_IMPORTED_MODULE_1_redux_extra__["store"].getState();
                            cmpRef.setState(currentState[payload.path]);
                        });
                    }
                }
            }
            var currentState = __WEBPACK_IMPORTED_MODULE_1_redux_extra__["store"].getState();
            var storeobjects = {};
            for (var commontag in __WEBPACK_IMPORTED_MODULE_1_redux_extra__["reducerRegistry"].getCommonReducers()) {
                if (commontag == 'context' || commontag == 'routing') {
                    storeobjects[commontag] = currentState[commontag];
                } else {
                    __WEBPACK_IMPORTED_MODULE_2_lodash_assign___default()(storeobjects, currentState[commontag]);
                }
                var key = __WEBPACK_IMPORTED_MODULE_1_redux_extra__["reducerRegistry"].getIncrement();
                this.subscriptions.push({ path: commontag, key: key });
                Object(__WEBPACK_IMPORTED_MODULE_1_redux_extra__["subscribe"])(commontag, key, function (payload) {
                    var currentState = __WEBPACK_IMPORTED_MODULE_1_redux_extra__["store"].getState();
                    if (payload.path == 'context' || payload.path == 'routing') {
                        var stateobj = {};
                        stateobj[payload.path] = currentState[payload.path];
                        cmpRef.setState(stateobj);
                    } else {
                        cmpRef.setState(currentState[payload.path]);
                    }
                });
            }
            for (var i = 0; i < reducertags.length; i++) {
                __WEBPACK_IMPORTED_MODULE_2_lodash_assign___default()(storeobjects, currentState[reducertags[i]]);
            }
            if (initalobjectvalues) {
                __WEBPACK_IMPORTED_MODULE_2_lodash_assign___default()(storeobjects, initalobjectvalues);
            }
            cmpRef.state = _extends({}, storeobjects);
            __WEBPACK_IMPORTED_MODULE_2_lodash_assign___default()(cmpRef, __WEBPACK_IMPORTED_MODULE_3__router__["b" /* routeActions */]);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.subscriptions.length > 0) {
                for (var i = 0; i < this.subscriptions.length; i++) {
                    Object(__WEBPACK_IMPORTED_MODULE_1_redux_extra__["unsubscribe"])(this.subscriptions[i].path, this.subscriptions[i].key);
                }
            }
        }
    }]);

    return BasePage;
}(__WEBPACK_IMPORTED_MODULE_0_react__["Component"]);



/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("lodash/assign");

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("react-router/lib/Route");

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = require("react-router/lib/Router");

/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = require("react-router/lib/IndexRoute");

/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("react-router/lib/useRouterHistory");

/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = require("history/lib/createMemoryHistory");

/***/ })
/******/ ]);
});